<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Editer_Req StructType
 * @subpackage Structs
 */
class Editer_Req extends AbstractStructBase
{
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Type;
    /**
     * The Demarche
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\TypeDemarcheEdition
     */
    public $Demarche;
    /**
     * The Identification
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TypeIdentification
     */
    public $Identification;
    /**
     * The Origine
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Origine;
    /**
     * The Canal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Canal;
    /**
     * Constructor method for Editer_Req
     * @uses Editer_Req::setType()
     * @uses Editer_Req::setDemarche()
     * @uses Editer_Req::setIdentification()
     * @uses Editer_Req::setOrigine()
     * @uses Editer_Req::setCanal()
     * @param string $type
     * @param \StructType\TypeDemarcheEdition $demarche
     * @param \StructType\TypeIdentification $identification
     * @param string $origine
     * @param string $canal
     */
    public function __construct($type = null, \StructType\TypeDemarcheEdition $demarche = null, \StructType\TypeIdentification $identification = null, $origine = null, $canal = null)
    {
        $this
            ->setType($type)
            ->setDemarche($demarche)
            ->setIdentification($identification)
            ->setOrigine($origine)
            ->setCanal($canal);
    }
    /**
     * Get Type value
     * @return string
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \EnumType\TypeDocument::valueIsValid()
     * @uses \EnumType\TypeDocument::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \StructType\Editer_Req
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\TypeDocument::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\TypeDocument', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \EnumType\TypeDocument::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Demarche value
     * @return \StructType\TypeDemarcheEdition
     */
    public function getDemarche()
    {
        return $this->Demarche;
    }
    /**
     * Set Demarche value
     * @param \StructType\TypeDemarcheEdition $demarche
     * @return \StructType\Editer_Req
     */
    public function setDemarche(\StructType\TypeDemarcheEdition $demarche = null)
    {
        $this->Demarche = $demarche;
        return $this;
    }
    /**
     * Get Identification value
     * @return \StructType\TypeIdentification|null
     */
    public function getIdentification()
    {
        return $this->Identification;
    }
    /**
     * Set Identification value
     * @param \StructType\TypeIdentification $identification
     * @return \StructType\Editer_Req
     */
    public function setIdentification(\StructType\TypeIdentification $identification = null)
    {
        $this->Identification = $identification;
        return $this;
    }
    /**
     * Get Origine value
     * @return string|null
     */
    public function getOrigine()
    {
        return $this->Origine;
    }
    /**
     * Set Origine value
     * @param string $origine
     * @return \StructType\Editer_Req
     */
    public function setOrigine($origine = null)
    {
        // validation for constraint: string
        if (!is_null($origine) && !is_string($origine)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($origine, true), gettype($origine)), __LINE__);
        }
        $this->Origine = $origine;
        return $this;
    }
    /**
     * Get Canal value
     * @return string|null
     */
    public function getCanal()
    {
        return $this->Canal;
    }
    /**
     * Set Canal value
     * @uses \EnumType\TypeCanal::valueIsValid()
     * @uses \EnumType\TypeCanal::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $canal
     * @return \StructType\Editer_Req
     */
    public function setCanal($canal = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\TypeCanal::valueIsValid($canal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\TypeCanal', is_array($canal) ? implode(', ', $canal) : var_export($canal, true), implode(', ', \EnumType\TypeCanal::getValidValues())), __LINE__);
        }
        $this->Canal = $canal;
        return $this;
    }
}
